#include "stdafx.h"
#include <windows.h>
#include "misc.h"
#include "resource.h"


ULONGLONG GetLocalTime64( void )
{
	FILETIME ft;
	ULARGE_INTEGER ui;
	SYSTEMTIME st;

	GetLocalTime( &st );
	SystemTimeToFileTime( &st, &ft );
	ui.LowPart = ft.dwLowDateTime;
	ui.HighPart = ft.dwHighDateTime;
	return ui.QuadPart;
}

BOOL GetFileVersionDW( TCHAR *path, DWORD *value4 )
{
	DWORD	handle;
	DWORD	rlen;
	DWORD	*lang;
	BYTE	*buf;
	UINT	vlen;
	TCHAR	strLang[9];
	TCHAR	strStream[100];
	TCHAR	*strBuf;

	rlen = GetFileVersionInfoSize( path, &handle );
	buf = new BYTE[rlen];

	if ( ( path == NULL ) || ( value4 == NULL ) ) {
		return FALSE;
	}

	if ( buf ) {
		GetFileVersionInfo( path, handle, rlen, buf );
		
		if ( VerQueryValue( buf, _T("\\VarFileInfo\\Translation"), (LPVOID*)&lang, &vlen ) ) {
			_stprintf_s( strLang, 9, _T("%04x%04x"), LOWORD(*lang), HIWORD(*lang) );
			_stprintf_s( strStream, 100, _T("\\StringFileInfo\\%s\\ProductVersion"), strLang );
			if ( VerQueryValue( buf, strStream, (LPVOID*)&strBuf, &vlen ) ) {
				if ( _stscanf_s( strBuf, _T("%d,%d,%d,%d"), &value4[0], &value4[1], &value4[2], &value4[3] ) != 4 ) {
					_stscanf_s( strBuf, _T("%d.%d.%d.%d"), &value4[0], &value4[1], &value4[2], &value4[3] );
				}
				delete[] buf;
				return TRUE;
			}
		}

		delete[] buf;
		return FALSE;
	}

	return FALSE;
}

BOOL GetCopyright( TCHAR *path, TCHAR *cp, int len )
{
	DWORD	handle;
	DWORD	rlen;
	DWORD	*lang;
	BYTE	*buf;
	UINT	vlen;
	TCHAR	strLang[9];
	TCHAR	strStream[100];
	TCHAR	*strBuf;

	rlen = GetFileVersionInfoSize( path, &handle );
	buf = new BYTE[rlen];

	if ( ( path == NULL ) || ( cp == NULL ) ) {
		return FALSE;
	}

	if ( buf ) {
		GetFileVersionInfo( path, handle, rlen, buf );
		
		if ( VerQueryValue( buf, _T("\\VarFileInfo\\Translation"), (LPVOID*)&lang, &vlen ) ) {
			_stprintf_s( strLang, 9, _T("%04x%04x"), LOWORD(*lang), HIWORD(*lang) );
			_stprintf_s( strStream, 100, _T("\\StringFileInfo\\%s\\LegalCopyright"), strLang );
			if ( VerQueryValue( buf, strStream, (LPVOID*)&strBuf, &vlen ) ) {
				_tcscpy_s( cp, len, strBuf );
				delete[] buf;
				return TRUE;
			}
		}

		delete[] buf;
		return FALSE;
	}

	return FALSE;
}

// ^XNgCɃACRݒuEύX
BOOL SetTrayIcon( HWND hWnd, TRAY_COMMAND command, TCHAR *szTitle )
{
	NOTIFYICONDATA notif;
	static HWND hWndCopy;
	BOOL bRet;
	DWORD dwMessage;

	HINSTANCE hInstance = (HINSTANCE)GetWindowLong( hWnd, GWL_HINSTANCE );

	if ( command != TRAY_MODIFY ) {
		hWndCopy = hWnd;
	}

	memset( &notif, 0, sizeof(NOTIFYICONDATA) );

	notif.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_GENERALW));

	notif.cbSize = sizeof(NOTIFYICONDATA);
	notif.hWnd = hWnd;
	notif.uID = 0;
	notif.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	notif.uCallbackMessage = WM_TRAYICONMESSAGE;
	_tcscpy_s(notif.szTip, 64, szTitle );

	switch( command )
	{
	case TRAY_DELETE:
		dwMessage = NIM_DELETE;
		break;
	case TRAY_ADD:
		dwMessage = NIM_ADD;
		break;
	case TRAY_MODIFY:
		dwMessage = NIM_MODIFY;
		break;
	}
	bRet = Shell_NotifyIcon( dwMessage, &notif );
	if ( !bRet && ( GetLastError() == ERROR_TIMEOUT ) ) {
		do {
			Sleep( 2000 );
		} while( !( bRet = Shell_NotifyIcon( dwMessage, &notif ) ) );
	}
	return bRet;
}

